<?php
/**
 * Template for displaying Import/Export tab content
 *
 * This file is used to markup the admin-facing aspects of the plugin.
 *
 * @since      1.0.0
 *
 * @package    Wp2leads
 * @subpackage Wp2leads/admin/partials
 */

if ( ! defined( 'ABSPATH' ) ) {
    exit; // Exit if accessed directly.
}

?>
<div>
	<h2 class="catalog-header"><?php _e('Catalog', 'wp2leads') ?></h2>
	<?php 
		if (empty($_GET['welcome'])){
			echo '<a href="' . esc_url(get_admin_url(null, 'admin.php?page=wp2l-admin&tab=catalog&welcome=1')) . '">(' . __('Show more Instructions', 'wp2leads') . ')</a>';
		}
	?>
</div>
<hr>
<?php $w = Wp2leads_Catalog::show_welcome_text_1(); ?>
<div class="catalog_list api-processing-holder">
	<div class="catalog_tags">
		<button class="catalog-tag all active" data-tag=""><?php _e('All', 'wp2leads'); ?></button>
		<?php 
			if($all_tags = Wp2leads_Catalog::get_all_tags()) {
				foreach ($all_tags as $tag) {
					echo '<button class="catalog-tag tag-'.$tag['id'].'" data-tag="'.$tag['id'].'">'.$tag['name'].'</button> ';
				}
			} ?>
	</div>
	<div class="catalog_wrap"></div>
	<div class="load_more">
		<button type="submit" class="button button-primary"><?php _e('Load More', 'wp2leads') ?></button>
	</div>
	<div class="api-spinner-holder">
		<div class="api-spinner"></div>
	</div>
</div>

<?php Wp2leads_Catalog::show_welcome_text_2($w); ?>