<?php
/**
 * API Fields Section
 *
 * @package Wp2Leads/Partials/MapToAPI
 * @version 1.0.1.7
 */

if ( ! defined( 'ABSPATH' ) ) {
    exit;
}
?>

<h3 class="accordion-header strict<?php echo $is_initial_settings_done ? '' : ' disabled'; ?>"><?php _e( 'Fields', 'wp2leads' ) ?></h3>

<div class="accordion-body">
    <div id="inputFiledSearchKT">
        <input style="width: 100%; margin: 10px 0px;" type="text"
               placeholder="<?php _e( 'Enter Field name', 'wp2leads' ) ?>">
    </div>

    <div class="api-fields-wrapper">
        <div class="api_field_box">
            <div class="api_field_head">
                <p class="field_label"><?php _e( 'Email', 'wp2leads' ) ?></p>
                <p class="field_value"><?php _e( 'Choose an option', 'wp2leads' ) ?></p>
            </div>

            <div class="api_field_body">
                <fieldgroup id="api_email">
                    <?php
                    $api_options = ! empty( $api['fields']['api_email'] ) ? ! is_array( $api['fields']['api_email'] ) ? array( $api['fields']['api_email'] ) : $api['fields']['api_email'] : [];
                    ?>
                    <select class="api-field" name="api_email" multiple
                            data-api-option='<?php echo json_encode( $api_options, JSON_FORCE_OBJECT ); ?>'></select>
                </fieldgroup>
            </div>

            <div class="api-field__value"></div>
        </div>

        <?php foreach ( $fields as $fieldName => $fieldDescription ): ?>
            <div class="api_field_box">
                <div class="api_field_head">
                    <p class="field_label"><?php _e( $fieldDescription, 'wp2leads' ) ?></p>
                    <p class="field_value"><?php _e( 'Choose an option', 'wp2leads' ) ?></p>
                </div>

                <div class="api_field_body">
                    <fieldgroup id="api_<?php echo( $fieldName ) ?>">
                        <?php
                        $type          = ! empty( $api['fields'][ 'api_' . $fieldName ]['type'] ) ? $api['fields'][ 'api_' . $fieldName ]['type'] : 'text';
						$gmt          = ! empty( $api['fields'][ 'api_' . $fieldName ]['gmt'] ) ? $api['fields'][ 'api_' . $fieldName ]['gmt'] : false;
                        $api_options   = ! empty( $api['fields'][ 'api_' . $fieldName ] ) ? ! is_array( $api['fields'][ 'api_' . $fieldName ] ) ? array( $api['fields'][ 'api_' . $fieldName ] ) : $api['fields'][ 'api_' . $fieldName ] : [];
                        $table_columns = ! empty( $api_options['table_columns'] ) ? $api_options['table_columns'] : array();
                        ?>
                        <select
                                class="api-field"
                                name="api_<?php echo( $fieldName ) ?>"
                                multiple
                                data-api-option='<?php echo json_encode( $api_options, JSON_FORCE_OBJECT ); ?>'
                        ></select>
                        <select class="field-type">
                            <option value="">
                                <?php _e( '-- Select --', 'wp2leads' ) ?>
                            </option>
                            <option value="text" <?php echo 'text' === $type ? 'selected' : ''; ?>>
                                <?php _e( 'text', 'wp2leads' ) ?>
                            </option>
                            <option value="number" <?php echo 'number' === $type ? 'selected' : ''; ?>>
                                <?php _e( 'number', 'wp2leads' ) ?>
                            </option>
                            <option value="decimal" <?php echo 'decimal' === $type ? 'selected' : ''; ?>>
                                <?php _e( 'decimal', 'wp2leads' ) ?>
                            </option>
                            <option value="url" <?php echo 'url' === $type ? 'selected' : ''; ?>>
                                <?php _e( 'url', 'wp2leads' ) ?>
                            </option>
                            <option value="html" <?php echo 'html' === $type ? 'selected' : ''; ?>>
                                <?php _e( 'HTML', 'wp2leads' ) ?>
                            </option>
                            <option value="date" <?php echo 'date' === $type ? 'selected' : ''; ?>>
                                <?php _e( 'date', 'wp2leads' ) ?>
                            </option>
                            <option value="time" <?php echo 'time' === $type ? 'selected' : ''; ?>>
                                <?php _e( 'time', 'wp2leads' ) ?>
                            </option>
							<option value="datetime" <?php echo 'datetime' === $type ? 'selected' : ''; ?>>
                                <?php _e( 'date + time', 'wp2leads' ) ?>
                            </option>
                        </select>
						<label style="<?php if('time' !== $type && 'datetime' !== $type) echo 'display: none;'; ?>">
							<input type="checkbox" data-showtypes='["time","datetime"]' name="convert_to_gmt" class="convert-to-gmt" <?php if($gmt) echo 'checked="checked"'; ?>> <span class="name"><?php _e('Convert time to GMT', 'wp2leads'); ?></span>
						</label>
                    </fieldgroup>
                </div>

                <div class="api-field__value"></div>
            </div>
        <?php endforeach; ?>
    </div>
</div>